unit MyTest_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, adxAddIn, MyTest_TLB, StdVcl;

type
  TADX_MyTest = class(TadxAddin, IADX_MyTest)
  protected
    function Get_AdvisorCode: PChar; safecall;
    procedure Set_AdvisorCode(Value: PChar); safecall;
  end;

  TAddInModule = class(TadxCOMAddInModule)
    procedure adxCOMAddInModuleAddInInitialize(Sender: TObject);
  private
    FAdvisorCode: string;
  protected
  public
  end;

implementation

{$R *.dfm}

{ TADX_MyTest }

function TADX_MyTest.Get_AdvisorCode: PChar;
begin
  Result := PChar(TAddInModule(Self.COMAddInModule).FAdvisorCode);
end;

procedure TADX_MyTest.Set_AdvisorCode(Value: PChar);
begin
  TAddInModule(Self.COMAddInModule).FAdvisorCode := StrPas(Value);
end;

{ TAddInModule }

procedure TAddInModule.adxCOMAddInModuleAddInInitialize(Sender: TObject);
begin
  FAdvisorCode := 'value';
end;

initialization
  TadxFactory.Create(ComServer, TADX_MyTest, CLASS_ADX_MyTest, TAddInModule);

end.
