unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ComObj, Office2000, Excel2000, MyTest_TLB;

procedure TForm1.Button1Click(Sender: TObject);
var
  IExcel: _Application;
  IAddIn: COMAddIn;
  i: Integer;
  V: OleVariant;
  Guid: string;

  MyObject: IADX_MyTest;
begin
  try
    IExcel := GetActiveOleObject('Excel.Application') as _Application;
  except
    IExcel := nil;
  end;
  if Assigned(IExcel) then
  try
    //
    Guid := GuidToString(CLASS_ADX_MyTest);
    for i := 1 to IExcel.COMAddIns.Count do begin
      V := i;
      if IExcel.COMAddIns.Item(V).Guid = Guid then begin
        IAddIn := IExcel.COMAddIns.Item(V);
        Break;
      end;
    end;

    if Assigned(IAddIn) then
      try
        if IAddIn.Connect then begin
          MyObject := IAddIn.Object_ as IADX_MyTest;

          ShowMessage(MyObject.AdvisorCode);

          MyObject.AdvisorCode := 'new value';

          ShowMessage(MyObject.AdvisorCode);

          MyObject := nil;
        end;
      finally
        IAddIn := nil;
      end;
  finally
    IExcel := nil;
  end;
end;

end.
